;================================================================================
// PCM samples at 15720Hz, with 4 bits, sample values in range[0,15]
;================================================================================
PlaySamplePCM_target_start = $600
;================================================================================

	.proc PlaySamplePCM, PlaySamplePCM_target_start
	pha				; save return bank

Init
	lda #%10000000
	sta GRAFP0
	lda #14
	sta COLPM0
	
    lda #0
    sta AUDCTL
    sta AUDC2
	sta AUDF1
	sta AUDF2
	
    lda #$18
    sta AUDC1
	
    ldy #>$C000			// end of cart buffer window (+1)

FirstBankSMAddress
	ldx #SAMPLE1_FIRST_BANK		// first bank for the sample, that needs to be in consecutive banks
	sta $d500,x
	
	sta WSYNC
	sta WSYNC
	
PlayLoop
    lda SampleCartBuffer		// values in the range 0 - 15
	
	ora #$10				// only volume bit
	
    sta WSYNC			// only one for sample rate 15720 in NTSC (15600 in PAL)
	
    sta AUDC1
	
	// asl
	// sta COLBK

	clc
	adc #[128-24]
	sta HPOSP0
	
    inc PlayLoop+1
    bne PlayLoop
    inc PlayLoop+2
	
    cpy PlayLoop+2
	
    bne PlayLoop
	
    lda #>SampleCartBuffer		// reset pointer for next bank
    sta PlayLoop+2
	
	inx
	sta $d500,x

LastBankSMAddress
	cpx #[SAMPLE1_FIRST_BANK + SAMPLE1_CART_BANKS]
	bne PlayLoop

ExitPlayLoop
	lda #$18
	sta AUDC1

	lda #0
	sta GRAFP0
	
	pla
	tax
	sta $d500,x		; enable return bank
	
	rts
	.endp
	
PlaySamplePCM_size = .len PlaySamplePCM
PlaySamplePCM_cart_start = .adr PlaySamplePCM

