;================================================================================
// PWM samples at 15720Hz, with <7 bits, sample values in range[0,109]
// this is just the same as before, but used to test the idea of one WSYNC
// every two scan lines, and proper timing in between..
;================================================================================
PlaySamplePWM3_target_start = $700
;================================================================================

	.proc PlaySamplePWM3, PlaySamplePWM3_target_start
	pha				; save return bank

Init
	lda #255
	sta AUDF2			// channel 2, high byte always = 255
    lda #$AF			// pure tone (distortion 10), max vol (15), for channel 1
    sta AUDC1
    lda #$50			// Clock channel one with 1.79 MHz + Join channels two and one (16 bit)
    sta AUDCTL
	
	lda #32				// number of pages for 8k
	sta m_bankPages

	lda #0
	sta m_samplePointer
	lda #>SampleCartBuffer
	sta m_samplePointer+1

	ldy #0
	
FirstBankSMAddress
	ldx #SAMPLE1_FIRST_BANK		// first bank for the sample, that needs to be in consecutive banks
	sta $d500,x

	sta WSYNC
	sta WSYNC

PlayLoop
    lda (m_samplePointer),y
	
    sta WSYNC
	
    sta AUDF1
    sta STIMER
	
    iny			// 2 cycles
	
	// we need 105 cycles between both "sta stimer", so here we need 90 cycles
	jsr DummyTime		// 6 cycles
	
    lda (m_samplePointer),y		// 5 cycles
    sta AUDF1					// 4 cycles
    sta STIMER					// 4 cycles
	
	iny
    bne PlayLoop
	
    inc m_samplePointer+1
	
    dec m_bankPages
    bne PlayLoop
	
	lda #32				// number of pages for 8k
	sta m_bankPages
	
    lda #>SampleCartBuffer		// reset pointer for next bank
    sta m_samplePointer+1
	
	inx
	sta $d500,x

LastBankSMAddress
	cpx #[SAMPLE1_FIRST_BANK + SAMPLE1_CART_BANKS]
	bne PlayLoop

ExitPlayLoop
	lda #$18
	sta AUDC1
	
	pla
	tax
	sta $d500,x		; enable return bank
	
	rts


DummyTime		// needs to burn 84 cycles..
	tya			// 2 cycles
	ldy #14		// 2 cycles
	
DummyLoop		// for the loop there is (5*14 - 1) = 69
	dey
	bne DummyLoop
	
	beq DummyJump	// 3 cycles
DummyJump

	tay			// 2 cycles
	
	rts			// 6 cycles
	
	.endp
	
PlaySamplePWM3_size = .len PlaySamplePWM3
PlaySamplePWM3_cart_start = .adr PlaySamplePWM3

