;================================================================================
// PWM samples at 7860Hz, with <8 bits, sample values in range[0,223]
;================================================================================
PlaySamplePWM2_target_start = $500
;================================================================================

	.proc PlaySamplePWM2, PlaySamplePWM2_target_start
	pha				; save return bank

Init
	lda #%11100000
	sta GRAFP0
	lda #$2E
	sta COLPM0
	
	lda #255
	sta AUDF2			// channel 2, high byte always = 255

    lda #$AF			// pure tone (distortion 10), max vol (15), for channel 1
    sta AUDC1
	
    lda #$50			// Clock channel one with 1.79 MHz + Join channels two and one (16 bit)
    sta AUDCTL
	
    ldy #>$C000			// end of cart buffer window (+1)

FirstBankSMAddress
	ldx #SAMPLE1_FIRST_BANK		// first bank for the sample, that needs to be in consecutive banks
	sta $d500,x
	
	sta WSYNC
	sta WSYNC
	
PlayLoop
    lda SampleCartBuffer		// values in the range 0 - 223
	
    sta WSYNC
    sta WSYNC			// two for sample rate 7860 in NTSC (7800 in PAL)
	
    sta AUDF1			// change channel 1 (low byte)
    sta STIMER
	
	// sta COLBK
		
	clc
	adc #[128-112]
	sta HPOSP0
	
    inc PlayLoop+1
    bne PlayLoop
    inc PlayLoop+2
	
    cpy PlayLoop+2
	
    bne PlayLoop
	
    lda #>SampleCartBuffer		// reset pointer for next bank
    sta PlayLoop+2
	
	inx
	sta $d500,x

LastBankSMAddress
	cpx #[SAMPLE1_FIRST_BANK + SAMPLE1_CART_BANKS]
	bne PlayLoop

ExitPlayLoop
	lda #$18
	sta AUDC1
	
	lda #0
	sta GRAFP0
	
	pla
	tax
	sta $d500,x		; enable return bank
	
	rts
	.endp
	
PlaySamplePWM2_size = .len PlaySamplePWM2
PlaySamplePWM2_cart_start = .adr PlaySamplePWM2

